#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){

	ofSetVerticalSync(true);
	ofBackground(0, 0, 0);
	playbackStartTime = 0;
	
	
}


//--------------------------------------------------------------
void testApp::update(){
	for (int i=0; i<TPR.size(); i++) {
		TPR[i].update();
	}	
}

//--------------------------------------------------------------
void testApp::draw(){

	
	// -------------------------- draw the line
	for (int i = 0; i < TPR.size(); i++){
		TPR[i].draw();
	}
	
	for (int i=0; i<TPR.size(); i++) {
	// -------------------------- draw the point at the current time
	if (TPR[i].bHaveADrawing()){			// if we have a drawing to work with
		
		// figure out what time we are at, and make sure we playback cyclically (!)
		// use the duration here and make sure our timeToCheck is in the range of 0 - duration
		float timeToCheck = ofGetElapsedTimef() - playbackStartTime;
		while (timeToCheck > TPR[i].getDuration() && TPR[i].getDuration() > 0){
			timeToCheck -= TPR[i].getDuration();
		}
		
		// get the position and velocity at timeToCheck
		ofPoint pos = TPR[i].getPositionForTime(timeToCheck);
		ofPoint vel = TPR[i].getVelocityForTime(timeToCheck);
		
		// since velocity is a line, we want to know how long it is. 
		float lengthOfVel = ofDist(0,0,vel.x, vel.y);
		
		float soundVolume = ofMap(lengthOfVel, 0,200, 0,1);
		//loopingSound.setVolume(soundVolume);
		
		float pitch = ofMap(pos.y, 0, (float)ofGetHeight(), 2.5, 0.1);
		//loopingSound.setSpeed(pitch);
		
		ofEnableAlphaBlending();
		ofFill();
		ofSetColor(255,(i*20),(255.0/i),255-lengthOfVel);
		ofCircle(pos.x, pos.y, 2 + 10);
		//lengthOfVel
		ofDisableAlphaBlending();
		
		
		}
	}	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){
	if (key == OF_KEY_RETURN){
            TPR.clear();
    }

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	TPR[TPR.size()-1].addPoint(x,y);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	timePointRecorder temp;
	
	TPR.push_back(temp); 
	TPR[TPR.size()-1].startDrawing(x,y);
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
	for (int i = 0; i < TPR.size(); i++){
		TPR[i].endDrawing();
	}
	playbackStartTime = ofGetElapsedTimef();
}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}



